SystemOrganization addCategory: #'OpenDBXDriverSmalltalk-Dialect'!

Object subclass: #OpenDBX
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'OpenDBXDriverSmalltalk-Dialect'!

!OpenDBX class methodsFor: 'constants' stamp: 'MarianoMartinezPeck 10/9/2009 19:27'!
current
	^ Current ifNil: [ Current := SqueakOpenDBX ffiImplementationForOS ] 
	! !

!OpenDBX class methodsFor: 'constants' stamp: 'MarianoMartinezPeck 10/8/2009 00:14'!
current: anObject
	^Current := anObject! !

!OpenDBX class methodsFor: 'constants' stamp: 'MarianoMartinezPeck 10/1/2009 17:25'!
currentOpenDBXVersion
	^'1.4.4'! !

!OpenDBX class methodsFor: 'constants' stamp: 'MarianoMartinezPeck 3/25/2010 22:14'!
reset
	^Current := nil! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 11:19'!
resultDone
	"ODBX_RES_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultTimeout
	^1! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:21'!
resultWithRows
	^3! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/29/2008 13:20'!
resultWithoutRows
	^2! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:11'!
rowDone
	"ODBX_ROW_DONE"
	^0! !

!OpenDBX class methodsFor: 'constants' stamp: 'EL 6/28/2008 09:10'!
rowNext
	"ODBX_ROW_NEXT"
	^1! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiBind: handle database: databaseName name: userName password: password method: method
	"int odbx_bind(odbx_t* handle, const char* database, const char* who, const char* cred,int method )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiError: handle number: err
	"long odbx_error(odbx_t*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'HMC 10/11/2008 10:41'!
apiErrorType: handle number: err 
	"int odbx_error_type( odbx_t* , int error )"
	^ self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiFinalize: handle 
	"long odbx_finish(odbx_t*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiGetOption: handle option: anOption value: aValue
	"int odbx_get_option(odbx_t* handle, unsigned int option,void* value)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:47'!
apiInitialize: handle backend: backend host: host port: port
	"long odbx_init(odbx_t**, char*, char*, char*)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiOpenLarge: aResultSetHandleNumber handle: aLargeHandleWordArray value: aString
	"int odbx_lo_open(odbx_result_t* result, odbx_lo_t** lo, const char* value)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQuery: handle query: query length: length
	"long odbx_query(odbx_t*, char*, ulong)"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnLength: handle index: index
	"unsigned long odbx_field_length( odbx_result_t* result, unsigned long pos ) "
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnName: handle index: index
	"char* odbx_column_name(odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumnType: handle index: index
	"char* odbx_column_type( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryColumns: handle
	"int odbx_column_count(odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFetchRow: handle 
	"int odbx_row_fetch( odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFieldValue: handle index: index
	"const char* odbx_field_value( odbx_result_t* result, unsigned long pos )"
	"IMPORTANT: Index es zero-based"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:48'!
apiQueryFinalize: handle
	"int odbx_result_finish( odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiQueryResult: connectionHandle handle: handle timeout: timeout chunk: chunk
	"int odbx_result( odbx_t* handle, odbx_result_t** result, struct timeval* timeout, unsigned long chunk )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiQueryRowsAffected: handle
	"uint64_t odbx_rows_affected(odbx_result_t* result )"
	^self subclassResponsibility! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiSetOption: handle option: anOption value: aValue
	"int odbx_set_option(odbx_t* handle, unsigned int option, void* value ) "
	^self subclassResponsibility	
! !

!OpenDBX methodsFor: 'api calls' stamp: 'EL 8/6/2008 09:49'!
apiUnbind: handle 
	"int odbx_unbind(odbx_t*)"
	^self subclassResponsibility! !

Object subclass: #SqueakDBXSmalltalkDialect
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'OpenDBXDriverSmalltalk-Dialect'!

!SqueakDBXSmalltalkDialect class methodsFor: 'garbage-collect' stamp: 'MarianoMartinezPeck 10/8/2009 00:44'!
addObjectToGarbageCollect: anObject
"Tells someway the garbage collect that anObject should "	
	^ self subclassResponsibility ! !

!SqueakDBXSmalltalkDialect class methodsFor: 'garbage-collect' stamp: 'MarianoMartinezPeck 10/8/2009 00:44'!
connectionsToGarbageCollect

	^ self subclassResponsibility ! !

!SqueakDBXSmalltalkDialect class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/9/2009 19:26'!
current
	^ Current ifNil: [ Current := SqueakDBXSqueakDialect ] 
	! !

!SqueakDBXSmalltalkDialect class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/7/2009 23:48'!
current: anObject
	Current := anObject! !
